# -*- coding: utf-8 -*-
# type: ignore
from __future__ import annotations

import http

from django.test import Client
from django.urls import reverse
import pytest
from pytest_django import asserts

from hotpocket_backend_testing.services.accounts import (
    AccessTokensTestingService,
)


@pytest.mark.django_db
def test_ok(authenticated_client: Client,
            access_token_out,
            ):
    # When
    result = authenticated_client.post(
        reverse('ui.accounts.apps.delete', args=(access_token_out.pk,)),
        data={
            'canhazconfirm': 'hai',
        },
    )

    # Then
    asserts.assertRedirects(
        result,
        reverse('ui.accounts.apps.browse'),
        fetch_redirect_response=False,
    )

    AccessTokensTestingService().assert_deleted(
        pk=access_token_out.pk, reference=access_token_out,
    )


@pytest.mark.django_db
def test_ok_htmx(authenticated_client: Client,
                 access_token_out,
                 ):
    # When
    result = authenticated_client.post(
        reverse('ui.accounts.apps.delete', args=(access_token_out.pk,)),
        headers={
            'HX-Request': 'true',
        },
        data={
            'canhazconfirm': 'hai',
        },
    )

    # Then
    assert result.status_code == http.HTTPStatus.OK

    expected_payload = {
        'status': 'ok',
        'result': True,
    }
    assert result.json() == expected_payload


@pytest.mark.django_db
def test_invalid_all_missing(authenticated_client: Client,
                             access_token_out,
                             ):
    # When
    result = authenticated_client.post(
        reverse('ui.accounts.apps.delete', args=(access_token_out.pk,)),
        data={
        },
    )

    # Then
    assert result.status_code == http.HTTPStatus.OK

    AccessTokensTestingService().assert_not_deleted(
        pk=access_token_out.pk, reference=access_token_out,
    )

    assert 'canhazconfirm' in result.context['form'].errors


@pytest.mark.django_db
def test_invalid_all_empty(authenticated_client: Client,
                           access_token_out,
                           ):
    # When
    result = authenticated_client.post(
        reverse('ui.accounts.apps.delete', args=(access_token_out.pk,)),
        data={
            'canhazconfirm': '',
        },
    )

    # Then
    assert result.status_code == http.HTTPStatus.OK

    AccessTokensTestingService().assert_not_deleted(
        pk=access_token_out.pk, reference=access_token_out,
    )

    assert 'canhazconfirm' in result.context['form'].errors


@pytest.mark.django_db
def test_other_account_access_token(authenticated_client: Client,
                                    other_account_access_token_out,
                                    ):
    # When
    result = authenticated_client.post(
        reverse('ui.accounts.apps.delete', args=(other_account_access_token_out.pk,)),
        data={
            'canhazconfirm': 'hai',
        },
    )

    # Then
    assert result.status_code == http.HTTPStatus.FORBIDDEN


@pytest.mark.django_db
def test_inactive_account(inactive_account_client: Client,
                          access_token_out,
                          ):
    # When
    result = inactive_account_client.post(
        reverse('ui.accounts.apps.delete', args=(access_token_out.pk,)),
        data={
            'canhazconfirm': 'hai',
        },
    )

    # Then
    asserts.assertRedirects(
        result,
        reverse(
            'ui.accounts.login',
            query=[
                ('next', reverse('ui.accounts.apps.delete', args=(access_token_out.pk,))),
            ],
        ),
        fetch_redirect_response=False,
    )


@pytest.mark.django_db
def test_anonymous(client: Client,
                   access_token_out,
                   ):
    # When
    result = client.post(
        reverse('ui.accounts.apps.delete', args=(access_token_out.pk,)),
        data={
            'canhazconfirm': 'hai',
        },
    )

    # Then
    asserts.assertRedirects(
        result,
        reverse(
            'ui.accounts.login',
            query=[
                ('next', reverse('ui.accounts.apps.delete', args=(access_token_out.pk,))),
            ],
        ),
        fetch_redirect_response=False,
    )
